# Spyt
# by Eresse <eresse@eresse.net>

# External Includes
require 'aromat'

# Internal Includes
require 'spyt/levels'
require 'spyt/loggable/logger'

# Spyt Module
module Spyt

	# Loggable Module:
	# Include this into anything to provide logging capability.
	module Loggable

		# Log:
		# Logger Access
		# @return [Logger] A Logger tailored to the containing object
		def log
			@logger ||= Logger.new self.try(:name) || self.try(:class).try(:name) || self.to_s
		end

		def self.extended base
			base.send(:define_method, :log) { base.log } if base.is_a? Class
		end
	end
end
