# Spyt
# by Eresse <eresse@eresse.net>

# External Includes
require 'aromat'
require 'spiffup'

# Internal Includes
require 'spyt/levels'

# Spyt Module
module Spyt

	# Loggable Module
	module Loggable

		# Logger Class:
		# Internal class used by Loggable module to provide logging methods.
		class Logger

			# Construct:
			# Builds a *Logger* to represent a given _source_.
			# @param [String] source Name of this logger's source
			def initialize source
				@source = source
			end

			# Generic Log Handler:
			# Proxy to Log::method_missing
			def method_missing name, *args
				super unless LEVELS.include? name
				Spyt.send name, @source, *args
			end
		end
	end
end
